<?php
/*
Plugin Name: Widget Icon
Description: Enhance your website with 280+ icons designed for Twitter Bootstrap. Just select an icon and display it in any widget on your WordPress site.
Version: 1.0.1
Author: dFactory
Author URI: http://www.dfactory.eu/
Plugin URI: http://www.dfactory.eu/plugins/widget-icon/
License: MIT License
License URI: http://opensource.org/licenses/MIT

Widget Icon
Copyright (C) 2013, Digital Factory - info@digitalfactory.pl

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/


class WidgetIcon
{
	private $icons = array(
		'icon-move' => '&#xe074;',
		'icon-music' => '&#xe073;',
		'icon-network' => '&#xe072;',
		'icon-off' => '&#xe071;',
		'icon-ok' => '&#xe070;',
		'icon-ok-circle' => '&#xe06f;',
		'icon-ok-sign' => '&#xe06e;',
		'icon-paper-clip' => '&#xe06d;',
		'icon-paper-clip-alt' => '&#xe06c;',
		'icon-path' => '&#xe06b;',
		'icon-plus-sign' => '&#xe059;',
		'icon-print' => '&#xe058;',
		'icon-qrcode' => '&#xe057;',
		'icon-question' => '&#xe056;',
		'icon-question-sign' => '&#xe055;',
		'icon-quotes' => '&#xe054;',
		'icon-quotes-alt' => '&#xe053;',
		'icon-random' => '&#xe052;',
		'icon-record' => '&#xe051;',
		'icon-reddit' => '&#xe050;',
		'icon-refresh' => '&#xe04f;',
		'icon-screenshot' => '&#xe03f;',
		'icon-search' => '&#xe03e;',
		'icon-search-alt' => '&#xe03d;',
		'icon-share' => '&#xe03c;',
		'icon-share-alt' => '&#xe03b;',
		'icon-shopping-cart' => '&#xe03a;',
		'icon-shopping-cart-sign' => '&#xe039;',
		'icon-signal' => '&#xe038;',
		'icon-skype' => '&#xe037;',
		'icon-slideshare' => '&#xe036;',
		'icon-smiley' => '&#xe035;',
		'icon-th-large' => '&#xe023;',
		'icon-th-list' => '&#xe022;',
		'icon-thumbs-down' => '&#xe021;',
		'icon-thumbs-up' => '&#xe020;',
		'icon-time' => '&#xe01f;',
		'icon-time-alt' => '&#xe01e;',
		'icon-tint' => '&#xe01d;',
		'icon-torso' => '&#xe01c;',
		'icon-trash' => '&#xe01b;',
		'icon-trash-alt' => '&#xe01a;',
		'icon-tumblr' => '&#xe019;',
		'icon-w3c' => '&#xe00a;',
		'icon-warning-sign' => '&#xe009;',
		'icon-website' => '&#xe008;',
		'icon-website-alt' => '&#xe007;',
		'icon-wheelchair' => '&#xe006;',
		'icon-wordpress' => '&#xe005;',
		'icon-wrench' => '&#xe004;',
		'icon-wrench-alt' => '&#xe003;',
		'icon-youtube' => '&#xe002;',
		'icon-zoom-in' => '&#xe001;',
		'icon-zoom-out' => '&#xe000;',
		'icon-pause-alt' => '&#xe069;',
		'icon-pencil' => '&#xe068;',
		'icon-pencil-alt' => '&#xe067;',
		'icon-person' => '&#xe066;',
		'icon-phone' => '&#xe065;',
		'icon-phone-alt' => '&#xe064;',
		'icon-photo' => '&#xe063;',
		'icon-photo-alt' => '&#xe062;',
		'icon-picasa' => '&#xe061;',
		'icon-picture' => '&#xe060;',
		'icon-pinterest' => '&#xe05f;',
		'icon-plane' => '&#xe05e;',
		'icon-play-alt' => '&#xe05c;',
		'icon-play-circle' => '&#xe05b;',
		'icon-plus' => '&#xe05a;',
		'icon-remove' => '&#xe04e;',
		'icon-remove-circle' => '&#xe04d;',
		'icon-remove-sign' => '&#xe04c;',
		'icon-repeat' => '&#xe04b;',
		'icon-repeat-alt' => '&#xe04a;',
		'icon-resize-full' => '&#xe049;',
		'icon-resize-horizontal' => '&#xe048;',
		'icon-resize-small' => '&#xe047;',
		'icon-resize-vertical' => '&#xe046;',
		'icon-retweet' => '&#xe045;',
		'icon-reverse-alt' => '&#xe044;',
		'icon-road' => '&#xe043;',
		'icon-rss' => '&#xe042;',
		'icon-screen' => '&#xe041;',
		'icon-screen-alt' => '&#xe040;',
		'icon-smiley-alt' => '&#xe034;',
		'icon-speaker' => '&#xe033;',
		'icon-stackoverflow' => '&#xe032;',
		'icon-star' => '&#xe031;',
		'icon-star-alt' => '&#xe030;',
		'icon-star-empty' => '&#xe02f;',
		'icon-stop-alt' => '&#xe02b;',
		'icon-stumbleupon' => '&#xe02a;',
		'icon-tag' => '&#xe029;',
		'icon-tags' => '&#xe028;',
		'icon-tasks' => '&#xe027;',
		'icon-text-height' => '&#xe026;',
		'icon-text-width' => '&#xe025;',
		'icon-th' => '&#xe024;',
		'icon-twitter' => '&#xe018;',
		'icon-universal-access' => '&#xe017;',
		'icon-unlock' => '&#xe016;',
		'icon-unlock-alt' => '&#xe015;',
		'icon-upload' => '&#xe014;',
		'icon-user' => '&#xe013;',
		'icon-video' => '&#xe012;',
		'icon-video-alt' => '&#xe011;',
		'icon-video-chat' => '&#xe010;',
		'icon-view-mode' => '&#xe00f;',
		'icon-vimeo' => '&#xe00e;',
		'icon-vkontakte' => '&#xe10e;',
		'icon-volume-down' => '&#xe00d;',
		'icon-volume-off' => '&#xe00c;',
		'icon-volume-up' => '&#xe00b;',
		'icon-backward' => '&#xe0ab;',
		'icon-fast-backward' => '&#xe09a;',
		'icon-fast-forward' => '&#xe099;',
		'icon-forward' => '&#xe093;',
		'icon-play' => '&#xe05d;',
		'icon-step-backward' => '&#xe02e;',
		'icon-step-forward' => '&#xe02d;',
		'icon-briefcase' => '&#xe10d;',
		'icon-bullhorn' => '&#xe10c;',
		'icon-calendar' => '&#xe10b;',
		'icon-calendar-sign' => '&#xe10a;',
		'icon-address-book' => '&#xe0dd;',
		'icon-address-book-alt' => '&#xe0dc;',
		'icon-adjust' => '&#xe0db;',
		'icon-adult' => '&#xe0da;',
		'icon-align-center' => '&#xe0d9;',
		'icon-align-justify' => '&#xe0d8;',
		'icon-align-left' => '&#xe0d7;',
		'icon-align-right' => '&#xe0d6;',
		'icon-arrow-down' => '&#xe0d5;',
		'icon-arrow-left' => '&#xe0d4;',
		'icon-arrow-right' => '&#xe0af;',
		'icon-arrow-up' => '&#xe0ae;',
		'icon-asl' => '&#xe0ad;',
		'icon-asterisk' => '&#xe0ac;',
		'icon-ban-circle' => '&#xe0aa;',
		'icon-barcode' => '&#xe0d3;',
		'icon-behance' => '&#xe0d2;',
		'icon-bell' => '&#xe0d1;',
		'icon-blind' => '&#xe0d0;',
		'icon-blogger' => '&#xe0cf;',
		'icon-bold' => '&#xe0ce;',
		'icon-book' => '&#xe0f5;',
		'icon-bookmark' => '&#xe0f4;',
		'icon-bookmark-empty' => '&#xe0f3;',
		'icon-braille' => '&#xe0f2;',
		'icon-camera' => '&#xe0a9;',
		'icon-cc' => '&#xe0a8;',
		'icon-certificate' => '&#xe0a7;',
		'icon-check' => '&#xe0a6;',
		'icon-check-empty' => '&#xe0a5;',
		'icon-chevron-down' => '&#xe0a4;',
		'icon-chevron-left' => '&#xe0cd;',
		'icon-chevron-right' => '&#xe0cc;',
		'icon-chevron-up' => '&#xe0cb;',
		'icon-child' => '&#xe0ca;',
		'icon-circle-arrow-down' => '&#xe0c9;',
		'icon-circle-arrow-left' => '&#xe0c8;',
		'icon-circle-arrow-right' => '&#xe0f1;',
		'icon-circle-arrow-up' => '&#xe0f0;',
		'icon-cloud' => '&#xe0ef;',
		'icon-cloud-alt' => '&#xe0ee;',
		'icon-cog' => '&#xe109;',
		'icon-cog-alt' => '&#xe108;',
		'icon-cogs' => '&#xe107;',
		'icon-comment' => '&#xe106;',
		'icon-comment-alt' => '&#xe0a3;',
		'icon-compass' => '&#xe0a2;',
		'icon-compass-alt' => '&#xe0a1;',
		'icon-credit-card' => '&#xe0a0;',
		'icon-css' => '&#xe09f;',
		'icon-dashboard' => '&#xe09e;',
		'icon-delicious' => '&#xe0c7;',
		'icon-deviantart' => '&#xe0c6;',
		'icon-digg' => '&#xe0c5;',
		'icon-download' => '&#xe0c4;',
		'icon-download-alt' => '&#xe0c3;',
		'icon-dribble' => '&#xe0c2;',
		'icon-edit' => '&#xe0ed;',
		'icon-eject' => '&#xe0ec;',
		'icon-envelope' => '&#xe0eb;',
		'icon-envelope-alt' => '&#xe0ea;',
		'icon-error' => '&#xe105;',
		'icon-error-alt' => '&#xe104;',
		'icon-exclamation-sign' => '&#xe103;',
		'icon-eye-close' => '&#xe102;',
		'icon-eye-open' => '&#xe09d;',
		'icon-facebook' => '&#xe09c;',
		'icon-facetime-video' => '&#xe09b;',
		'icon-female' => '&#xe098;',
		'icon-file' => '&#xe0c1;',
		'icon-file-alt' => '&#xe0c0;',
		'icon-file-edit' => '&#xe0bf;',
		'icon-file-edit-alt' => '&#xe0be;',
		'icon-file-new' => '&#xe0bd;',
		'icon-file-new-alt' => '&#xe0bc;',
		'icon-film' => '&#xe0e9;',
		'icon-filter' => '&#xe0e8;',
		'icon-fire' => '&#xe0e7;',
		'icon-flag' => '&#xe0e6;',
		'icon-flag-alt' => '&#xe101;',
		'icon-flickr' => '&#xe100;',
		'icon-folder' => '&#xe0ff;',
		'icon-folder-close' => '&#xe0fe;',
		'icon-folder-open' => '&#xe097;',
		'icon-folder-sign' => '&#xe096;',
		'icon-font' => '&#xe095;',
		'icon-fontsize' => '&#xe094;',
		'icon-forward-alt' => '&#xe092;',
		'icon-foursquare' => '&#xe0bb;',
		'icon-friendfeed' => '&#xe0ba;',
		'icon-friendfeed-rect' => '&#xe0b9;',
		'icon-fullscreen' => '&#xe0b8;',
		'icon-gift' => '&#xe0b7;',
		'icon-github' => '&#xe0b6;',
		'icon-github-text' => '&#xe0e5;',
		'icon-glass' => '&#xe0e4;',
		'icon-glasses' => '&#xe0e3;',
		'icon-globe' => '&#xe0e2;',
		'icon-globe-alt' => '&#xe0fd;',
		'icon-googleplus' => '&#xe0fc;',
		'icon-graph' => '&#xe0fb;',
		'icon-graph-alt' => '&#xe0fa;',
		'icon-group' => '&#xe091;',
		'icon-group-alt' => '&#xe090;',
		'icon-guidedog' => '&#xe08f;',
		'icon-hand-down' => '&#xe08e;',
		'icon-hand-left' => '&#xe08d;',
		'icon-hand-right' => '&#xe08c;',
		'icon-hand-up' => '&#xe0b5;',
		'icon-hdd' => '&#xe0b4;',
		'icon-headphones' => '&#xe0b3;',
		'icon-hearing-impaired' => '&#xe0b2;',
		'icon-heart' => '&#xe0b1;',
		'icon-heart-alt' => '&#xe0b0;',
		'icon-heart-empty' => '&#xe0e1;',
		'icon-home' => '&#xe0e0;',
		'icon-home-alt' => '&#xe0df;',
		'icon-idea' => '&#xe0de;',
		'icon-idea-alt' => '&#xe0f9;',
		'icon-inbox' => '&#xe0f8;',
		'icon-inbox-alt' => '&#xe0f7;',
		'icon-inbox-box' => '&#xe0f6;',
		'icon-indent-left' => '&#xe08b;',
		'icon-indent-right' => '&#xe08a;',
		'icon-info-sign' => '&#xe089;',
		'icon-instagram' => '&#xe088;',
		'icon-iphone-home' => '&#xe087;',
		'icon-italic' => '&#xe086;',
		'icon-key' => '&#xe085;',
		'icon-laptop' => '&#xe084;',
		'icon-laptop-alt' => '&#xe083;',
		'icon-leaf' => '&#xe082;',
		'icon-linkedin' => '&#xe081;',
		'icon-list' => '&#xe080;',
		'icon-list-alt' => '&#xe07f;',
		'icon-lock' => '&#xe07e;',
		'icon-lock-alt' => '&#xe07d;',
		'icon-magnet' => '&#xe07c;',
		'icon-male' => '&#xe07b;',
		'icon-map-marker' => '&#xe07a;',
		'icon-map-marker-alt' => '&#xe079;',
		'icon-mic' => '&#xe078;',
		'icon-mic-alt' => '&#xe077;',
		'icon-minus' => '&#xe076;',
		'icon-minus-sign' => '&#xe075;',
		'icon-pause' => '&#xe06a;',
		'icon-fork' => '&#xe10f;',
		'icon-broom' => '&#xe110;',
		'icon-return-key' => '&#xe111;',
		'icon-lastfm' => '&#xe112;',
		'icon-livejournal' => '&#xe113;',
		'icon-myspace' => '&#xe114;',
		'icon-soundcloud' => '&#xe115;',
		'icon-viadeo' => '&#xe116;',
		'icon-spotify' => '&#xe117;',
		'icon-caret-left' => '&#xe119;',
		'icon-caret-up' => '&#xe02c;',
		'icon-caret-right' => '&#xe118;',
		'icon-caret-down' => '&#xe11a;',
		'icon-stop' => '&#xe11b;'
	);
	private $defaults = array(
		'icon' => 'none',
		'icon_size' => 'standard',
		'place' => 'left',
		'padding_type' => 'pixel',
		'padding' => 10,
		'color_type' => 'inherit',
		'color' => '#000000',
		'vertical_align' => 'inherit'
	);
	private $aligns = array(
		'inherit',
		'baseline',
		'bottom',
		'middle',
		'sub',
		'super',
		'text-bottom',
		'text-top',
		'top'
	);
	private $icon_sizes = array(
		'standard',
		'icon-large',
		'icon-2x',
		'icon-3x',
		'icon-4x'
	);
	private $paddings = array(
		'pixel',
		'percent'
	);
	private $color_types = array(
		'inherit',
		'custom'
	);
	private $places = array(
		'left',
		'right'
	);


	public function __construct()
	{
		//actions
		add_action('plugins_loaded', array(&$this, 'load_textdomain'));
		add_action('in_widget_form', array(&$this, 'display_admin_widget_box_options'), 10, 3);
		add_action('admin_enqueue_scripts', array(&$this, 'admin_widgets_scripts_styles'));
		add_action('wp_enqueue_scripts', array(&$this, 'front_widgets_scripts_styles'));

		//filters
		add_filter('widget_display_callback', array(&$this, 'display_frontend_widgets'), 10, 3);
		add_filter('widget_update_callback', array(&$this, 'update_admin_widgets_options'), 10, 3);
		add_filter('plugin_row_meta', array(&$this, 'plugin_extend_links'), 10, 2);
		add_filter('plugin_action_links', array(&$this, 'plugin_settings_link'), 10, 2);
	}


	/**
	 * Loads text domain
	*/
	public function load_textdomain()
	{
		load_plugin_textdomain('widget-icon', FALSE, dirname(plugin_basename(__FILE__)).'/languages/');
	}
	
	
	/**
	 * Add links to Support Forum
	*/
	public function plugin_extend_links($links, $file) 
	{
		if (!current_user_can('install_plugins'))
			return $links;
	
		$plugin = plugin_basename(__FILE__);
		
		if ($file == $plugin) 
		{
			return array_merge(
				$links,
				array(sprintf('<a href="http://www.dfactory.eu/support/forum/widget-icon/" target="_blank">%s</a>', __('Support', 'widget-icon')))
			);
		}
		
		return $links;
	}
	
	
	/**
	 * Add links to Widgets page
	*/
	function plugin_settings_link($links, $file) 
	{
		if (!is_admin() || !current_user_can('edit_theme_options'))
			return $links;
			
		static $plugin;
		
		$plugin = plugin_basename(__FILE__);
		
		if ($file == $plugin) 
		{
			$settings_link = sprintf('<a href="%s">%s</a>', admin_url('widgets.php'), __('Widgets', 'widget-icon'));
			array_unshift($links, $settings_link);
		}
	
		return $links;
	}


	/**
	 * Loads admin-side scripts and styles
	*/
	public function admin_widgets_scripts_styles($page)
	{
		if($page !== 'widgets.php')
        	return;

		wp_enqueue_script('widget-icon', plugins_url('js/widget-icon.js', __FILE__), array('wp-color-picker'));

		wp_enqueue_style('wp-color-picker');
		wp_enqueue_style('elusive-style', plugins_url('assets/css/elusive-webfont.css', __FILE__));
		wp_enqueue_style('widget-icon-admin-style', plugins_url('css/widget-icon-admin.css', __FILE__));

	}


	/**
	 * Loads front-side scripts and styles
	*/
	public function front_widgets_scripts_styles($page)
	{
		global $wp_styles, $wp_scripts;

		wp_enqueue_style('elusive-style', plugins_url('assets/css/elusive-webfont.css', __FILE__));
		wp_enqueue_style('widget-icon-front-style', plugins_url('css/widget-icon-front.css', __FILE__));
		
		/* IE7 - To-do
		wp_register_style('elusive-ie7-style', plugins_url('assets/css/elusive-webfont-ie7.css', __FILE__));
		wp_enqueue_style('elusive-ie7-style');
		$wp_styles->add_data('elusive-ie7-style', 'conditional', 'lt IE 7' );
		
		wp_register_script('elusive-ie7-script', plugins_url('assets/js/lte-ie7.js', __FILE__));
		wp_enqueue_script('elusive-ie7-script');
		$wp_scripts->add_data('elusive-ie7-script', 'conditional', 'lt IE 7');
		*/
		
	}


	/**
	 * Displays widget box
	*/
	public function display_admin_widget_box_options($widget, $empty, $instance)
	{
		$icon = (isset($instance['wi_opt']['widget_icon']) ? $instance['wi_opt']['widget_icon'] : $this->defaults['icon']);
		$place = (isset($instance['wi_opt']['widget_place']) ? $instance['wi_opt']['widget_place'] : $this->defaults['place']);
		$padding_type = (isset($instance['wi_opt']['widget_padding_type']) ? $instance['wi_opt']['widget_padding_type'] : $this->defaults['padding_type']);
		$padding = (isset($instance['wi_opt']['widget_padding']) ? $instance['wi_opt']['widget_padding'] : $this->defaults['padding']);
		$color_type = (isset($instance['wi_opt']['widget_color_type']) ? $instance['wi_opt']['widget_color_type'] : $this->defaults['color_type']);
		$color = (isset($instance['wi_opt']['widget_color']) ? $instance['wi_opt']['widget_color'] : $this->defaults['color']);
		$icon_size = (isset($instance['wi_opt']['widget_icon_size']) ? $instance['wi_opt']['widget_icon_size'] : $this->defaults['icon_size']);
		$vertical_align = (isset($instance['wi_opt']['widget_vertical_align']) ? $instance['wi_opt']['widget_vertical_align'] : $this->defaults['vertical_align']);

		$widget_color_type = $widget->get_field_name('widget_color_type');
		$widget_color_type_str = str_replace(array('][', ']', '['), '-', $widget_color_type);
		$widget_padding_type = $widget->get_field_name('widget_padding_type');
		$widget_padding_type_str = str_replace(array('][', ']', '['), '-', $widget_padding_type);

		echo '
		<div class="widget-icon">
			<p class="label">'.__('Select widget icon', 'widget-icon').'</p>
			<select name="'.$widget->get_field_name('widget_icon').'" class="widget-icon-selection">
				<option value="none" '.selected($icon, 'none', FALSE).'>'.__('-- none --', 'widget-icon').'</option>';

		ksort($this->icons, SORT_STRING);

		foreach($this->icons as $name => $code)
		{
			echo '
				<option value="'.$name.'" '.selected($icon, $name, FALSE).'>'.$code.'&nbsp;&nbsp;'.$name.'</option>';
		}

		echo '
			</select>
			<p class="label">'.__('Select icon position', 'widget-icon').'</p>
			<select name="'.$widget->get_field_name('widget_place').'" class="widget-icon-place">
				<option value="left" '.selected($place, 'left', FALSE).'>'.__('left of the widget title', 'widget-icon').'</option>
				<option value="right" '.selected($place, 'right', FALSE).'>'.__('right of the widget title', 'widget-icon').'</option>
			</select>
			<p class="label">'.__('Icon padding', 'widget-icon').'</p>
			<input type="text" name="'.$widget->get_field_name('widget_padding').'" value="'.$padding.'" size="4" />
			<input id="'.$widget_padding_type_str.'_pixel" type="radio" name="'.$widget_padding_type.'" value="pixel" '.checked($padding_type, 'pixel', FALSE).' /> <label for="'.$widget_padding_type_str.'_pixel">'.__('px', 'widget-icon').'</label>
			<input id="'.$widget_padding_type_str.'_percent" type="radio" name="'.$widget_padding_type.'" value="percent" '.checked($padding_type, 'percent', FALSE).' /> <label for="'.$widget_padding_type_str.'_percent">'.__('%', 'widget-icon').'</label>
			<p class="label">'.__('Vertical align', 'widget-icon').'</p>
			<select name="'.$widget->get_field_name('widget_vertical_align').'">';

		foreach($this->aligns as $align)
		{
			echo '
				<option value="'.$align.'" '.selected($vertical_align, $align, FALSE).'>'.$align.'</option>';
		}

		echo '
			</select>
			<p class="label">'.__('Icon size', 'widget-icon').'</p>
			<select name="'.$widget->get_field_name('widget_icon_size').'">';

		foreach($this->icon_sizes as $size)
		{
			echo '
				<option value="'.$size.'" '.selected($icon_size, $size, FALSE).'>'.__($size, 'widget-icon').'</option>';
		}

		echo '
			</select>
			<p class="label">'.__('Icon color', 'widget-icon').'</p>
			<input class="wi_ct_inheir" id="'.$widget_color_type_str.'_inherit" type="radio" name="'.$widget_color_type.'" value="inherit" '.checked($color_type, 'inherit', FALSE).' /> <label for="'.$widget_color_type_str.'_inherit">'.__('inherit', 'widget-icon').'</label>
			<input class="wi_ct_custom" id="'.$widget_color_type_str.'_custom" type="radio" name="'.$widget_color_type.'" value="custom" '.checked($color_type, 'custom', FALSE).' /> <label for="'.$widget_color_type_str.'_custom">'.__('custom', 'widget-icon').'</label>
			<div id="'.$widget_color_type_str.'_div"'.($color_type === 'inherit' ? ' style="display: none;"' : '').'><input type="text" value="'.$color.'" class="widget-icon-color-picker" name="'.$widget->get_field_name('widget_color').'" data-default-color="'.$color.'" /></div>
		</div>';
	}


	/**
	 * Saves widget box
	*/
	public function update_admin_widgets_options($instance, $new_instance)
	{
		//nothing set?
		if(!isset($new_instance['widget_icon'], $new_instance['widget_place'], $new_instance['widget_padding'], $new_instance['widget_padding_type'], $new_instance['widget_icon_size'], $new_instance['widget_vertical_align'], $new_instance['widget_color_type'], $new_instance['widget_color']))
		{
			unset($instance['wi_opt']);
		}
		else
		{
			//icon
			if(isset($new_instance['widget_icon']))
			{
				$instance['wi_opt']['widget_icon'] = sanitize_key($new_instance['widget_icon']);
			}
			else $instance['wi_opt']['widget_icon'] = $this->defaults['icon'];

			//place
			if(isset($new_instance['widget_place']) && in_array($new_instance['widget_place'], $this->places))
			{
				$instance['wi_opt']['widget_place'] = $new_instance['widget_place'];
			}
			else $instance['wi_opt']['widget_place'] = $this->defaults['place'];

			//padding
			if(isset($new_instance['widget_padding']))
			{
				$instance['wi_opt']['widget_padding'] = (int)$new_instance['widget_padding'];
			}
			else $instance['wi_opt']['widget_padding'] = $this->defaults['padding'];

			//padding type
			if(isset($new_instance['widget_padding_type']) && in_array($new_instance['widget_padding_type'], $this->paddings))
			{
				$instance['wi_opt']['widget_padding_type'] = $new_instance['widget_padding_type'];
			}
			else $instance['wi_opt']['widget_padding_type'] = $this->defaults['padding_type'];

			//icon size
			if(isset($new_instance['widget_icon_size']) && in_array($new_instance['widget_icon_size'], $this->icon_sizes))
			{
				$instance['wi_opt']['widget_icon_size'] = $new_instance['widget_icon_size'];
			}
			else $instance['wi_opt']['widget_icon_size'] = $this->defaults['icon_size'];

			//vertical align
			if(isset($new_instance['widget_vertical_align']) && in_array($new_instance['widget_vertical_align'], $this->aligns))
			{
				$instance['wi_opt']['widget_vertical_align'] = $new_instance['widget_vertical_align'];
			}
			else $instance['wi_opt']['widget_vertical_align'] = $this->defaults['vertical_align'];

			//color type
			if(isset($new_instance['widget_color_type']) && in_array($new_instance['widget_color_type'], $this->color_types))
			{
				if(($instance['wi_opt']['widget_color_type'] = $new_instance['widget_color_type']) === 'custom')
				{
					//color
					if(isset($new_instance['widget_color']))
					{
						if(preg_match('/^#[a-f0-9]{6}$/', $new_instance['widget_color']) === 1)
						{
							$instance['wi_opt']['widget_color'] = $new_instance['widget_color'];
						}
					}
					else $instance['wi_opt']['widget_color'] = $this->defaults['color'];
				}
			}
			else $instance['wi_opt']['widget_color_type'] = $this->defaults['color_type'];
		}

		return $instance;
	}


	/**
	 * Manages front-end display of widgets
	*/
	public function display_frontend_widgets($instance, $widget_class, $args)
	{
		if(isset($instance['wi_opt']['widget_icon']) && $instance['wi_opt']['widget_icon'] !== 'none')
		{
			$color = ($instance['wi_opt']['widget_color_type'] === 'inherit' ? '' : 'color: '.$instance['wi_opt']['widget_color'].';');

			$padding = ($instance['wi_opt']['widget_padding'] !== 0 ? ($instance['wi_opt']['widget_place'] === 'right' ? 'padding-left: ' : 'padding-right: ').$instance['wi_opt']['widget_padding'].($instance['wi_opt']['widget_padding_type'] === 'percent' ? '%' : 'px').';' : '');

			$vertical_align = ' vertical-align: '.$instance['wi_opt']['widget_vertical_align'].';';

			$icon = ($instance['wi_opt']['widget_icon'] !== 'none' ? '<i style="'.$color.$padding.$vertical_align.'" class="'.$instance['wi_opt']['widget_icon'].($instance['wi_opt']['widget_icon_size'] !== 'standard' ? ' '.$instance['wi_opt']['widget_icon_size'] : '').'"></i>' : '');

			$code = ($instance['wi_opt']['widget_place'] !== 'none' ? ($instance['wi_opt']['widget_place'] === 'left' ? '\1'.$icon.'\2\3' : '\1\2'.$icon.'\3') : '\1\2\3');

			ob_start();
			$widget_class->widget($args, $instance);
			$result = ob_get_clean();
			// Maybe there is a different way?
			$result = preg_replace('/(<h3 class="widget-title">)(.*?)(<\/h3>)/', $code, $result);
			$result = preg_replace('/(<h3 class="widgettitle">)(.*?)(<\/h3>)/', $code, $result); // Custom Community
			$result = preg_replace('/(<h2 class="widget-title">)(.*?)(<\/h2>)/', $code, $result); // Patchwork
			$result = preg_replace('/(<h2 class="widgettitle">)(.*?)(<\/h2>)/', $code, $result); // P2 theme
			$result = preg_replace('/(<div class="widget-title">)(.*?)(<\/div>)/', $code, $result); // Responsive theme
			$result = preg_replace('/(<div class="widgettitle">)(.*?)(<\/div>)/', $code, $result);

			echo $result;

			return FALSE;
		}

		else return $instance;
	}
}


$widget_icon_in = new WidgetIcon();
?>